export const lift = {
    Filter: (_raw, _socket) => {
        return {
            if_tc_ltc: _raw[0],
            if_tc_vitc1: _raw[1],
            if_tc_vitc2: _raw[2],
            if_afd1: _raw[3],
            if_afd2: _raw[4],
            if_334_cea_708_cdp: _raw[5],
            if_334_cea_608: _raw[6],
            if_334_program: _raw[7],
            if_334_data: _raw[8],
            if_334_vbi: _raw[9],
            if_vpid: _raw[10],
            if_2010_ansi_scte_104: _raw[11],
            if_2031_dvb_scte_vbi: _raw[12],
            if_rdd_8_op_47: _raw[13],
            if_obs: _raw[14],
            if_other: _raw[15]
        };
    },
    FinePrint: (_raw, _socket) => {
        return {
            on_checksum_error: _raw[0],
            tc_timeout_frames: _raw[1],
            afd_timeout_frames: _raw[2]
        };
    },
    ResponseStatistics: (_raw, _socket) => {
        return {
            packets_pending: _raw[0],
            packets_embedded_tc_ltc: _raw[1],
            packets_embedded_tc_vitc1: _raw[2],
            packets_embedded_tc_vitc2: _raw[3],
            packets_embedded_afd1: _raw[4],
            packets_embedded_afd2: _raw[5],
            packets_embedded_334_cea_708_cdp: _raw[6],
            packets_embedded_334_cea_608: _raw[7],
            packets_embedded_334_program: _raw[8],
            packets_embedded_334_data: _raw[9],
            packets_embedded_334_vbi: _raw[10],
            packets_embedded_vpid: _raw[11],
            packets_embedded_2010_ansi_scte_104: _raw[12],
            packets_embedded_2031_dvb_scte_vbi: _raw[13],
            packets_embedded_rdd_8_op_47: _raw[14],
            packets_embedded_obs: _raw[15],
            packets_embedded_other: _raw[16],
            packets_overflow: _raw[17],
            packets_bad_checksum: _raw[18],
            packets_incompatible_framerate: _raw[19]
        };
    },
    VANCEmbedderLocations: (_raw, _socket) => {
        return {
            if_tc_ltc: _raw[0],
            if_tc_vitc1: _raw[1],
            if_tc_vitc2: _raw[2],
            if_afd1: _raw[3],
            if_afd2: _raw[4],
            if_334_cea_708_cdp: _raw[5],
            if_334_cea_608: _raw[6],
            if_334_program: _raw[7],
            if_334_data: _raw[8],
            if_334_vbi: _raw[9],
            if_vpid: _raw[10],
            if_2010_ansi_scte_104: _raw[11],
            if_2031_dvb_scte_vbi: _raw[12],
            if_rdd_8_op_47: _raw[13],
            if_obs: _raw[14],
            if_other: _raw[15]
        };
    },
};
export const lower = {
    Filter: (_x, _socket) => [
        _x.if_tc_ltc,
        _x.if_tc_vitc1,
        _x.if_tc_vitc2,
        _x.if_afd1,
        _x.if_afd2,
        _x.if_334_cea_708_cdp,
        _x.if_334_cea_608,
        _x.if_334_program,
        _x.if_334_data,
        _x.if_334_vbi,
        _x.if_vpid,
        _x.if_2010_ansi_scte_104,
        _x.if_2031_dvb_scte_vbi,
        _x.if_rdd_8_op_47,
        _x.if_obs,
        _x.if_other
    ],
    FinePrint: (_x, _socket) => [
        _x.on_checksum_error,
        _x.tc_timeout_frames,
        _x.afd_timeout_frames
    ],
    ResponseStatistics: (_x, _socket) => [
        _x.packets_pending,
        _x.packets_embedded_tc_ltc,
        _x.packets_embedded_tc_vitc1,
        _x.packets_embedded_tc_vitc2,
        _x.packets_embedded_afd1,
        _x.packets_embedded_afd2,
        _x.packets_embedded_334_cea_708_cdp,
        _x.packets_embedded_334_cea_608,
        _x.packets_embedded_334_program,
        _x.packets_embedded_334_data,
        _x.packets_embedded_334_vbi,
        _x.packets_embedded_vpid,
        _x.packets_embedded_2010_ansi_scte_104,
        _x.packets_embedded_2031_dvb_scte_vbi,
        _x.packets_embedded_rdd_8_op_47,
        _x.packets_embedded_obs,
        _x.packets_embedded_other,
        _x.packets_overflow,
        _x.packets_bad_checksum,
        _x.packets_incompatible_framerate
    ],
    VANCEmbedderLocations: (_x, _socket) => [
        _x.if_tc_ltc,
        _x.if_tc_vitc1,
        _x.if_tc_vitc2,
        _x.if_afd1,
        _x.if_afd2,
        _x.if_334_cea_708_cdp,
        _x.if_334_cea_608,
        _x.if_334_program,
        _x.if_334_data,
        _x.if_334_vbi,
        _x.if_vpid,
        _x.if_2010_ansi_scte_104,
        _x.if_2031_dvb_scte_vbi,
        _x.if_rdd_8_op_47,
        _x.if_obs,
        _x.if_other
    ],
};
export const Enums = {
    OnChecksumError: ["InsertAnyway", "Discard"],
    MetadataType: ["M_TC_LTC", "M_TC_VITC1", "M_TC_VITC2", "M_AFD1", "M_AFD2", "M_334_CEA_708_CDP", "M_334_CEA_608", "M_334_Program", "M_334_Data", "M_334_VBI", "M_VPID", "M_2010_ANSI_SCTE_104", "M_2031_DVB_SCTE_VBI", "M_RDD_8_OP_47", "M_OBS", "M_Other"],
    FilterSetting: ["Insert", "Discard"],
    Event: ["ChannelEstablished", "ChannelClosed"],
    ChannelState: ["Connecting", "Connected"]
};
